<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Document</title>
</head>

<body>
    <div class="container">
        <div class="text-center my-4">
            <h3 class="text-info">Danh sách bài đăng của người dùng (POSTS OF USERS)</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-2">
                <label class="form-control border border-0 text-dark"> Điền user id: </label>
            </div>
            <div class="col-sm-6">
                <input type="text" class="form-control" id="inp-user-id" placeholder="Gợi ý user id đúng: 3, 4, 5...">
            </div>
            <div class="col-sm-4">
                <button class="btn btn-info form-control" id="btn-get-user-posts"> Lấy danh sách bài viết (post)
                </button>
            </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="tbl-user-posts">
            <thead>
                <tr>
                  <th>id</th>
                  <th>Post id</th>
                  <th>email</th>
                  <th>Name (nhan đề)</th>
                  <th>Body (nội dung)</th>
                  <th>Action</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>1</td>
                  <td>1</td>
                  <td>Eliseo@gardner.biz</td>
                  <td>id labore ex et quam laborum</td>
                  <td>laudantium enim quasi est quidem</td>
                  <td>Action (thao tác)</td>
                </tr>
                <tr>
                  <td>2</td>
                  <td>1</td>
                  <td>Jayne_Kuhic@sydney.com</td>
                  <td>quo vero reiciendis velit similique earum</td>
                  <td>est natus enim nihil est dolore omnis voluptatem numquam</td>
                  <td>Action (thao tác)</td>
                </tr>
              </tbody>
        </table>
    </div>


    <script>
        const gCOL_POSTID = 0;
        const gCOL_POSTTITLE = 1;
        const gCOL_POSTBODY = 2;
        const gCOL_ACTION = 3;
        $(document).ready(function () {
            $("#btn-get-user-posts").click(onBtnUserList);
        });
        // hàm sự kiện tìm list user
        function onBtnUserList() {
            var vObjUser = { userId: 0 };
            readDataUser(vObjUser);
            var vDuLieuHopLe = validateUserData(vObjUser);
            if (vDuLieuHopLe) {
                const vURL_GET_POST = "https://jsonplaceholder.typicode.com/posts/" + vObjUser.userId + "/comments/";
                $.ajax({
                    url: vURL_GET_POST,
                    type:'GET',
                    dataType: 'json',
                    success: function (responseObject) {
                        console.log(JSON.stringify(responseObject));
                        showDataUserFromTable(responseObject);
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText)
                    }
                });
            }
        }
        // 
        function readDataUser(paramPostObject) {
            paramPostObject.userId = parseInt($("#inp-user-id").val().trim());
        }
        //
        function validateUserData(paramPostObject) {
            if (isNaN(paramPostObject.userId)) {
                alert("Bạn phải nhập là số");
                return false;
            }
            return true;
        }
        //
        function showDataUserFromTable(paramPostObject) {
            var vTable = $("#tbl-user-posts tbody");
            vTable.html("");
            for (var bI = 0; bI < paramPostObject.length; bI++) {
                var bNewRow = $("<tr>").appendTo(vTable);

                $("<td>").html(paramPostObject[bI].id)
                    .appendTo(bNewRow);
                $("<td>").html(paramPostObject[bI].postId)
                    .appendTo(bNewRow);
                $("<td>").html(paramPostObject[bI].name)
                    .appendTo(bNewRow);
                $("<td>").html(paramPostObject[bI].email)
                    .appendTo(bNewRow);
                $("<td>").html(paramPostObject[bI].body)
                    .appendTo(bNewRow);
                //
                var bCellAction = $("<td>").addClass("btn-group").appendTo(bNewRow);
                var bDetailButton = $("<button>" , {html : "Chi tiết"})
                    .addClass("btn btn-info")
                    .data("id",paramPostObject[bI].id)
                    .appendTo(bCellAction);
                    bDetailButton.click(onBtnClickDetail);

            }
        }
        //
        function onBtnClickDetail(paramPostObject)
        {
            console.log("%cDetail button click. Sự kiện Click là: ....", "color:orange");
            var vButtonBiAn = paramPostObject.currentTarget ;
            const vDetail = "Task520B.html";
            var vUrlOpen = vDetail + "?" + "id=" + $(vButtonBiAn).data("id");
            window.location.href = vUrlOpen;
        }


    </script>
</body>

</html>